
public class LikelihoodEstimator {
    protected double[] initialLogSFSFactorial(int[] siteFreqSpectrum) {

        int length = siteFreqSpectrum.length;
        int[] copiedSFS = new int[length];

        System.arraycopy(siteFreqSpectrum, 0, copiedSFS, 0, length);
        QSort.sort(copiedSFS);

        double[] logSFS = new double[length];

        int preMut = 0;
        double preLogMut = 0;
        for (int i = 0; i < length; i ++) {
            int mut = copiedSFS[i];
            double logMut = preLogMut;
            for (int j = preMut + 1; j <= mut; j ++) {
                logMut += Math.log(j);
            }

            for (int j = 0; j < length; j ++) {
                if (mut == siteFreqSpectrum[j]) {
                    logSFS[j] = logMut;
                }
            }

            preMut = mut;
            preLogMut = logMut;
        }

        return logSFS;
    }

    protected double logLikelihood(double expectMut, int obsMut, double logObsMutFactorial) {
        if (expectMut == 0 && obsMut == 0) {
            return 0;
        }
        double logL = obsMut * Math.log(expectMut) - expectMut - logObsMutFactorial;

        return logL;
    }
}
