import org.kohsuke.args4j.CmdLineParser;

public class NumOfLineages {
	
	protected double run(NumOfLineagesInput numOfLineagesInput) {
		
		TableForLinearModel table = new TableForLinearModel();
		
		TableForLinearModel.tableDir = numOfLineagesInput.getTablesDir();
    	table.setSampleSize(numOfLineagesInput.getSampleSize());
    	table.initialMatrix();
    	
    	double t = numOfLineagesInput.getTime();
    	double expectedNumOfLineages = table.getAvgNumOfLineages(t);
    	
    	return expectedNumOfLineages;
	}

	public static void main(String[] args) throws Exception {

		NumOfLineagesInput numOfLineagesInput = new NumOfLineagesInput();
        CmdLineParser parser = new CmdLineParser(numOfLineagesInput);
        parser.parseArgument(args);

        NumOfLineages numOfLineages = new NumOfLineages();
        double expectedNum = numOfLineages.run(numOfLineagesInput);
        int n = numOfLineagesInput.getSampleSize();
        double time = numOfLineagesInput.getTime();
        
        System.out.println("n = " + n + " time = " + time + " expectedNumOfLineages = " + expectedNum);
        System.out.println();
    }
}
